class AR
 {
  public:

   static const int STAGES = 1;

   static const int NONE             = 0;
   static const int GAME_INTRO       = 1;
   static const int GAME_MENU        = 2;
   static const int GAME_PLAY        = 3;
   static const int GAME_OVER        = 4;
   static const int GAME_EXIT        = 5;
   static const int GAME_START       = 6;
   static const int GAME_PROLOGUE    = 7;
   static const int GAME_START_STAGE = 8;
   static const int GAME_START_WAVE  = 9;
   static const int GAME_END_WAVE    = 10;
   static const int GAME_SHOP        = 11;
   static const int GAME_EPILOGUE    = 12;
   static const int SHOOT            = 13;
   static const int FADE             = 14;
   static const int GENERATE         = 15;
   static const int PHYSICS          = 16;
   static const int MOVE_TO          = 17;
   static const int ANIMATE          = 18;
   static const int ANIMATE_TO       = 19;
   static const int SCALE_TO         = 20;
   static const int ATTACK           = 21;
   static const int ESCAPE           = 22;
   static const int HIT              = 23;
   static const int DOWN             = 24;
   static const int LAUNCHED         = 25;
   static const int FOLLOW           = 26;
   static const int FLASH            = 27;

   static const int CANNON_GENERIC = -2;
   static const int NO_CANNON      = -1;
   static const int CANNON_BASIC   = 0;
   static const int CANNON_FAST    = 1;
   static const int CANNON_LASER   = 2;
   static const int CANNON_TRIPLE  = 3;
   static const int CANNON_PLASMA  = 4;
   static const int CANNON_FLAME   = 5;
   static const int CANNON_SHELL   = 6;

   static const int ITEM_RADAR         = 0;
   static const int ITEM_SHIELD        = 1;
   static const int ITEM_HULL          = 2;
   static const int ITEM_TARGETTING    = 3;
   static const int ITEM_CARGO         = 4;
   static const int ITEM_ENEMIES_SCAN  = 5;
   static const int ITEM_REPAIR_HULL   = 6;
   static const int ITEM_REPAIR_SHIELD = 7;
   static const int ITEM_CANNON_ROTATE = 8;
   static const int ITEM_MISSILE       = 9;

   static const int NO_COLLISION           = 0;
   static const int NO_COLLISION_MASK      = 1;
   static const int STATIC_COLLISION_MASK  = 2;
   static const int DYNAMIC_COLLISION_MASK = 3;

   static const int RES_640x480  = 0;
   static const int RES_800x600  = 1;
   static const int RES_1024x768 = 2;
   static const int RES_1152x864 = 3;

   static string version() { return string("0.42"); }

   static string configFile() { return string("config.cfg"); }

   static string dataPath()       { return string("data/");                 }   
   static string objectPath()     { return string(dataPath() + "objects/"); }
   static string soundPath()      { return string(dataPath() + "sounds/");  }
   static string musicPath()      { return string(dataPath() + "musics/");  }
   static string stagePath(int n) {
	                               stringstream buffer;

	                               buffer << dataPath() << "stages/" << n << "/";
	                               return buffer.str();
	                              }
   
   static string errNoCoins() { return string("INSUFFICENT COINS, YOU CAN NOT PURCHASE THE ITEM!"); }

 };
