class AR_Util
 {
  public:

   static float radians(float degrees) { return degrees * ALLEGRO_PI / 180.0; }

   static float degrees(float radians) { return radians * 180.0 / ALLEGRO_PI; }

   static void wait(float t) { al_rest(t); }

   static string cutExtension(string filename)
    {
     // Return the filename without extension
     int start;
     string buffer;

     buffer = string(filename);
     start = buffer.rfind('.');
     if(start >= 0) buffer.erase(start,buffer.length());
     return buffer;
    }

   static int random(int max)
    {
     // Return a pseudocasual number from 0 to max (max included)
     max++;
     return(rand() % max);
    }

   static void errorBox(ALLEGRO_DISPLAY *display, string message)
    {
     al_show_native_message_box(display,"Error","",message.c_str(),NULL,ALLEGRO_MESSAGEBOX_ERROR);
	}

   static void printText(ALLEGRO_FONT *font, string text, int x, int y, int r = 255, int g = 255, int b = 255)
    {
     al_draw_text(font,al_map_rgb(r,g,b),x,y,0,text.c_str());
	}

   static void clearColor(int r, int g, int b)
    {
     al_clear_to_color(al_map_rgb(r,g,b));
	}

   static void rectangle(float x, float y, float w, float h, int r = 255, int g = 255, int b = 255, bool filled = true)
    {
     if(filled) al_draw_filled_rectangle(x,y,x+w,y+h,al_map_rgb(r,g,b));
     else       al_draw_rectangle       (x,y,x+w,y+h,al_map_rgb(r,g,b),1);
	}

   static void pixel(float x, float y, int r = 255, int g = 255, int b = 255)
    {
     al_draw_pixel(x,y,al_map_rgb(r,g,b));
	}

   static void loader(ALLEGRO_BITMAP *bg, ALLEGRO_FONT *font, string message, int percentage, int width, int height = 20, int position = 1, int r = 255, int g = 255, int b = 255)
    {
	 int percentage_width;
	 
	 percentage_width = width * percentage / 100;
     if(!bg) AR_Util::clearColor(0,0,0); else al_draw_bitmap(bg,0,0,0);
     al_draw_rectangle (1,position+1,width,             height,al_map_rgb(r,g,b),1);
     AR_Util::rectangle(2,position+2,percentage_width-4,height-5,r,g,b);
     AR_Util::printText(font,message,0,height + 5);
     al_flip_display();
	}

 };
