class Bullet : public AR_Sprite
 {
  private:

   int damage;

  public:

   Bullet(string filename, AR_Display *display, Bullet *p = NULL) : AR_Sprite(filename,display,0,0,p)
    {
	 reset();
	}

   ~Bullet() { }

   void run()
    {
	 AR_Sprite::run();
	 if(action == AR::SHOOT)
	  {
	   life--;
	   if(life == 0) action = AR::FADE;
      }
	 if(action == AR::FADE)
	  {
	   setAlpha(getAlpha() - 10);
	   if(getAlpha() == 0) action = AR::NONE;
      }
	}

   void draw() { if(action != AR::NONE) AR_Sprite::draw(); }

   void hit() { action = AR::NONE; }

   void shoot(float x, float y, float angle, float power, int life, float friction_x, float friction_y, float acceleration_x, float acceleration_y, float gravity_x, float gravity_y)
    {
	 if(action == AR::NONE)
	  {
	   //power = power + (float)AR_Util::random(10) * 0.1; //random factor TODO ???
       setX(x); setY(y);
       setSpeedX(power*(cos(AR_Util::radians(angle+AR_Util::random(2)-1))));
       setSpeedY(power*(-sin(AR_Util::radians(angle+AR_Util::random(2)-1))));
       setFrictionX(friction_x);
       setFrictionY(friction_y);
       setGravityX(gravity_x);
       setGravityY(gravity_y);
       setAccelerationX(acceleration_x);
       setAccelerationY(acceleration_y);
	   setAngle(angle);
	   setAlpha(200);
	   setLife(life);
	   action = AR::SHOOT;
      }
	}

   void reset()
    {
	 // Reset variables to default
	 AR_Sprite::reset();
	 damage = 0;
	 setCenterX(width>>1); setCenterY(height>>1);
	}

   int getDamage() { return damage; }
   
   void setDamage(int damage) { this->damage = damage; }

 };
