class Osd : public AR_Bitmap
 {
  protected:
  
   AR_Font *font; 
   AR_Sprite *icons;
   int *score, *coins;
   Player *player; // Pointer to player
   Stage  *stage;  // Pointer to current stage

   void reset()
    {
	 // Reset variables to default
	 AR_Bitmap::reset();
	}

  public:

   Osd(string filename, AR_Display *display, AR_Sprite *icons) : AR_Bitmap(filename,display,NULL)
    {
	 this->icons = icons;
	 font = new AR_Font("data/font_osd.png",display);
     score = coins = NULL;
	 reset();
    }

   ~Osd() { }

   void draw()
    {
	 stringstream buffer;
	 int fh;
     Weapon **wea;
     Item   **ite;

     if(!enable) return;

     fh = font->getLineHeight() + 3;
     wea = player->getWeaponsP();
     ite = player->getItemsP();
     AR_Bitmap::draw();

     // Draw OSD variables
	 buffer.str(""); buffer << "SCORE " << *score;
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 3,  (int)this->y + 5+fh*0);
	 buffer.str(""); buffer << "COINS " << *coins;
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 228,(int)this->y + 5+fh*0);
	 if(player->isRadarEnable()) { buffer.str(""); buffer << "*" << player->getRadarRange(); }
	 else                          buffer.str("---");
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 984,(int)this->y + 5+fh*0);
	 if(player->getScanEnemiesRemaining()) { buffer.str(""); buffer << *player->getRemainingEnemiesP(); }
	 else                                    buffer.str("---");
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 984,(int)this->y + 5+fh*1);
	 if(player->getScanEnemiesHealth()) buffer.str("ON");
	 else                               buffer.str("OFF");
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 984,(int)this->y + 5+fh*2);
	 if(player->getScanEnemiesShields()) buffer.str("ON");
	 else                                buffer.str("OFF");
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 984,(int)this->y + 5+fh*3);
     
     if(player->getCurrentWeapon(0) == AR::NO_CANNON)
      {
       buffer.str("1. NO CANNON");
       AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 363,(int)this->y + 5);
      }
     else
      {
       buffer.str(""); buffer << "1. " << wea[player->getCurrentWeapon(0)]->getName();
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 363,(int)this->y + 5);
       icons->setX((int)this->x + 364); icons->setY((int)this->y + 25); icons->setCurrentFrame(wea[player->getCurrentWeapon(0)]->getIconFrame()); icons->draw();
	   buffer.str(""); buffer << "*" << player->getCannon(0)->getRotationSpeed() * 100 + 12;
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 429,(int)this->y + 3+fh*1);
	   if(player->getCannon(0)->getEnableTargetting()) { buffer.str(""); buffer << "*" << player->getCannon(0)->getTargettingRangeScale(); }
	   else                                              buffer.str("---");
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 497,(int)this->y + 3+fh*1);
      }

     if(player->getCurrentWeapon(1) == AR::NO_CANNON)
      {
       buffer.str("2. NO CANNON");
       AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 547,(int)this->y + 5);
      }
     else
      {
       buffer.str(""); buffer << "2. " << wea[player->getCurrentWeapon(1)]->getName();
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 547,(int)this->y + 5);
	   icons->setX((int)this->x + 548); icons->setY((int)this->y + 25); icons->setCurrentFrame(wea[player->getCurrentWeapon(1)]->getIconFrame()); icons->draw();
	   buffer.str(""); buffer << "*" << player->getCannon(1)->getRotationSpeed() * 100 + 12;
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 613,(int)this->y + 3+fh*1);
	   if(player->getCannon(1)->getEnableTargetting()) { buffer.str(""); buffer << "*" << player->getCannon(1)->getTargettingRangeScale(); }
	   else                                              buffer.str("---");
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 681,(int)this->y + 3+fh*1);
      }

     // Draw bars
     AR_Util::rectangle(x-center_x + 25,y-center_y + 27, player->getHealth()      *200/player->getMaxHealth(),      19,0,  200,0);
	 buffer.str(""); buffer << player->getHealth() << "/" << player->getMaxHealth();
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 228,(int)this->y + 5+fh*1);

     if(player->isShieldEnable())
      {
       AR_Util::rectangle(x-center_x + 25,y-center_y + 50,player->getShieldHealth()*140/player->getShieldMaxHealth(),19,0,200,0);
	   buffer.str(""); buffer << player->getShieldHealth() << "/" << player->getShieldMaxHealth();
	   AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 168,(int)this->y + 5+fh*2);
       buffer.str(""); buffer << (display->getMaxFPS() * 60) / player->getShieldRechargeStep() << "/MIN";
       AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 292,(int)this->y + 5+fh*2);
      }
	 else {
		   if(player->getShieldDown()) {
			                            buffer.str(""); buffer << "0" << "/" << player->getShieldMaxHealth();
	                                    AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 168,(int)this->y + 5+fh*2);
                                        buffer.str("0/MIN");
                                        AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 293,(int)this->y + 5+fh*2);
		                               }
		   else                        {
			                            buffer.str("---/---");
			                            AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 168,(int)this->y + 5+fh*2);
			                            buffer.str("-/MIN");
			                            AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 292,(int)this->y + 5+fh*2);
									   }
		  }

     AR_Util::rectangle(x-center_x + 25,y-center_y + 73,player->getCargo()*140/player->getMaxCargo(),19,180,0,0);
	 buffer.str(""); buffer << player->getCargo() << "/" << player->getMaxCargo();
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 168,(int)this->y + 5+fh*3);
	 buffer.str(""); buffer << 18 - player->getDecayStep() << "/SEC";
	 AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 292,(int)this->y + 5+fh*3);

	 if(player->getMissileLauncher()->getWeapon() == AR::NO_CANNON) buffer.str("---");
	 else
	  {
       AR_Util::rectangle(x-center_x + 384,y-center_y + 74,player->getMissileLauncher()->getReloadCount()*110/player->getMissileLauncher()->getReloadTime(),19,0,0,200);
	   buffer.str(""); buffer << "*" << 14-(float)(player->getMissileLauncher()->getReloadTime())/100;
	  }
     AR_Util::printText(font->getFont(),buffer.str(),(int)this->x + 518,(int)this->y + 5+fh*3);

     // Draw radar
     drawRadar();
    }

   void drawRadar()
    {
	 float rw,rh,sw,sh,x0,y0,rx,ry,ra_w,ra_h;
	 float range;
     Object **objects;

     range = player->getRadarRange();
	 rw = 228;
	 rh = 89;
	 sw = stage->getMapWidth(1);
	 sh = stage->getMapHeight(1);
	 x0 = 0 + 730;
	 y0 = 672 + 5;
	 ra_w = rw/sw / range;
	 ra_h = rh/sh / range;

     // Radar disable
     if(!player->isRadarEnable())
      {
       AR_Util::rectangle(x0,y0,rw,rh,6,6,6);
       AR_Util::rectangle(x0+5,   y0+5, 2,40,160,160,160);
       AR_Util::rectangle(x0+5,   y0+50,2, 5,160,160,160);
       AR_Util::rectangle(x0+rw-5,y0+70,2,12,160,160,160);
       return;
	  }

     // Radar area
     rx = ra_w*player->getScrollX()+x0;
     ry = ra_h*player->getScrollY()+y0;
     AR_Util::rectangle(rx,ry,ra_w*display->getWidth(),ra_h*stage->getMapHeight(1),0,200,0,false);
     
	 // Player
	 rx = ra_w*player->getX()+x0;
	 ry = ra_h*player->getY()+y0;
	 AR_Util::pixel(rx,ry);

	 // Hunters
	 objects = player->getHuntersP();
	 for(int i=0;i<N_HUNTERS;i++)
	  if(objects[i]->getEnable())
	   {
        rx = ra_w*objects[i]->getX()+x0;
        ry = ra_h*objects[i]->getY()+y0;
        if(rx>=x0 && rx<=x0+rw && ry>=y0 && ry<=y0+rh) AR_Util::pixel(rx,ry);
	   }
	 // Armadillos
	 objects = player->getArmadillosP();
	 for(int i=0;i<N_ARMADILLOS;i++)
	  if(objects[i]->getEnable())
	   {
        rx = ra_w*objects[i]->getX()+x0;
        ry = ra_h*objects[i]->getY()+y0;
        if(rx>=x0 && rx<=x0+rw && ry>=y0 && ry<=y0+rh) AR_Util::pixel(rx,ry);
	   }

	 // Bandits
	 objects = player->getBanditsP();
	 for(int i=0;i<N_BANDITS;i++)
	  if(objects[i]->getEnable())
	   {
        rx = ra_w*objects[i]->getX()+x0;
        ry = ra_h*objects[i]->getY()+y0;
        if(rx>=x0 && rx<=x0+rw && ry>=y0 && ry<=y0+rh) AR_Util::pixel(rx,ry);
	   }

	 // Cruisers
	 objects = player->getCruisersP();
	 for(int i=0;i<N_CRUISERS;i++)
	  if(objects[i]->getEnable())
	   {
        rx = ra_w*objects[i]->getX()+x0;
        ry = ra_h*objects[i]->getY()+y0;
        if(rx>=x0 && rx<=x0+rw && ry>=y0 && ry<=y0+rh) AR_Util::pixel(rx,ry);
	   }
	}

   void setScoreP(int *score)      { this->score = score;     }

   void setCoinsP(int *coins)      { this->coins  = coins;    }
   
   void setPlayerP(Player *player) { this->player = player;   }
   
   void setStageP(Stage *stage)    { this->stage = stage;     }
   
   AR_Font *getFont() { return font; }

 };
